Index: /main/trunk/gli/src/org/greenstone/gatherer/util/GS3ServerThread.java
===================================================================
--- /main/trunk/gli/src/org/greenstone/gatherer/util/GS3ServerThread.java	(revision 31583)
+++ /main/trunk/gli/src/org/greenstone/gatherer/util/GS3ServerThread.java	(revision 31584)
@@ -55,69 +55,4 @@
     }
     
-    public void old_run()
-    {
-	try
-	    {
-		///System.err.println("**** GS3 server : " + _ant_command);
-
-		String shellCommand = null;
-		Process p = null;
-		if (Utility.isWindows())
-		    {
-			if(_ant_command.indexOf("start") != -1) { // running an "ant (re)start" command on windows, run start
-			    _ant_command = "start";
-			}
-			// The path in quotes, and the entire sequence of commands in quotes as well
-			// E.g. the following works: cmd /C "cd "C:\path\to\greenstone3" && ant stop"
-			// and it preserves any spaces in the path to GSDL3SRCHOME (_gsdl3_src_path).
-			p = Runtime.getRuntime().exec("cmd /C \"cd \"" + _gsdl3_src_path + File.separator + "\" && ant " + _ant_command + "\"");	
-		    }
-		else
-		    {
-			if(_ant_command.indexOf("start") != -1) { // if running an "ant (re)start" command on non-Windows, run restart
-			    _ant_command = "restart";
-			}
-			p = Runtime.getRuntime().exec(new String[]{"/bin/bash", "-c", "ant " + _ant_command + " -f \"" + _gsdl3_src_path + File.separator + "build.xml\""});
-		    }
-
-		if (p != null) {
-			// in order for the process.waitFor() method to work with Java 6 (JRE 6 is included in GS binaries)
-			// need to make sure the IOstreams of the process are not blocked. For Java 7, this is not necessary
-			// and a waitFor() is sufficient. But with Java 6, the waitFor() causes the server to finally start
-			// after the user has quit GLI.
-		
-			// Process takes no input, but we will still catch this iostream too
-			// And we'll catch the error and output streams to prevent them from blocking during waitFor()
-			// (For normal input and output stream handling using the Gobblers, see FormatConversionDialog.java)
-			SafeProcess.OutputStreamGobbler inputGobbler
-			    = new SafeProcess.OutputStreamGobbler(p.getOutputStream());			
-			SafeProcess.InputStreamGobbler errorGobbler
-			    = new SafeProcess.InputStreamGobbler(p.getErrorStream(), true);
-			SafeProcess.InputStreamGobbler outputGobbler
-			    = new SafeProcess.InputStreamGobbler(p.getInputStream());
-            
-            errorGobbler.start();
-            outputGobbler.start();
-			inputGobbler.start();
-			
-			// the important part: wait for the process (ant stop or start or re-start to terminate)
-			int result = p.waitFor();
-			if(result != 0) {
-			System.err.println("**** Failed to successfully " + _ant_command + " the GS3 server.");
-			}		
-			
-			outputGobbler.join();
-			errorGobbler.join();
-			inputGobbler.join();
-		} else {
-		    System.err.println("**** Could not start the Process to " + _ant_command + " the GS3 server.");
-		}
-
-	    }
-	catch(Exception ex)
-	    {
-		ex.printStackTrace();
-	    }
-    }
 
     public void run()
@@ -172,30 +107,4 @@
     }
 
-    public static void old_stopServer() {
-
-	System.err.println("Stopping GS3 Server");
-	try {
-	    String shellCommand = null;
-	    Process p = null;
-	    if (Utility.isWindows()) {
-		// cmd /C "cd "C:\path\to\greenstone3" && ant stop"
-		p = Runtime.getRuntime().exec("cmd /C \"cd \"" + Configuration.gsdl3_src_path + File.separator + "\" && ant stop\"");	
-	    } else {
-		p = Runtime.getRuntime().exec(new String[]{"/bin/bash", "-c", "ant stop -f \"" + Configuration.gsdl3_src_path + File.separator + "build.xml\""});
-	    }
-	    // doing a p.waitFor() without processing the Process' IOstreams causes blocking with Java 6 
-	    // (i.e. when JRE 6 included with GS binaries). However, p.waitFor() with Java 7 is fine.
-	    /*if(p != null && p.waitFor() == 0) {
-	      DebugStream.println("********** SUCCESSFULLY stopped THE GS3 SERVER ON EXIT");
-	      }
-	      else {
-	      System.err.println("********** FAILED TO SUCCESSFULLY stop THE GS3 SERVER ON EXIT");
-	      //throw new Exception ("Failed to successfully stop the GS3 server on exit.");
-	      }*/
-	} catch(Exception e) {
-	    System.err.println("Exception when trying to stop the tomcat web server: " + e);
-	    DebugStream.printStackTrace(e);
-	}
-    }
 
     // can't call ant stop from its own thread - what if GLI has exited by then?